## openbios-sparc 1.0~alpha2+20070816

=== Makefile ===
ARCH= $(shell test -r rules.xml && cat rules.xml |grep "^ARCH" |cut -d\= -f2|tr -d \ )
HOSTARCH=$(shell config/scripts/archname)
CROSSCFLAGS=$(shell config/scripts/crosscflags $(HOSTARCH) $(ARCH))
ODIR=obj-$(ARCH)

all: requirements archtest info build

archtest: prepare
	@test -r config.xml -a -r rules.xml || \
		( echo ; echo "Please run the following command first:"; echo ; \
		  echo "  $$ config/scripts/switch-arch <arch>"; \
		  echo; echo "<arch> can be one out of x86, amd64, cross-ppc, ppc"; \
		  echo "       cross-sparc32, sparc32, cross-sparc64, sparc64"; \
		  echo; exit 1 )

requirements:
	@which toke &>/dev/null || ( echo ; echo "Please install the OpenBIOS fcode utilities."; \
			echo; echo "Download with :"; \
			echo "  $$ svn co svn://openbios.org/openbios/fcode-utils"; \
			echo; exit 1 )
	@which xsltproc &>/dev/null || ( echo ; echo "Please install libxslt2"; \
			echo; exit 1 )

info:
	@echo "Building OpenBIOS on $(HOSTARCH) for $(ARCH)"

clean:
	@printf "Cleaning up..."
	@rm -rf $(ODIR) forth.dict.core 
	@find . -type f -name "*~" -exec rm \{\} \;
	@echo " ok"

directories: clean
	@printf "Initializing build tree..."
	@mkdir $(ODIR)
	@mkdir -p $(ODIR)/target
	@mkdir -p $(ODIR)/target/include
	@mkdir -p $(ODIR)/target/arch
	@mkdir -p $(ODIR)/target/arch/unix
	@mkdir -p $(ODIR)/target/arch/$(ARCH)
	@mkdir -p $(ODIR)/target/arch/ppc
	@mkdir -p $(ODIR)/target/arch/ppc/briq # no autodetection of those..
	@mkdir -p $(ODIR)/target/arch/ppc/pearpc
	@mkdir -p $(ODIR)/target/arch/ppc/mol
	@mkdir -p $(ODIR)/target/arch/x86
	@mkdir -p $(ODIR)/target/arch/x86/xbox
	@mkdir -p $(ODIR)/target/libgcc
	@mkdir -p $(ODIR)/target/kernel
	@mkdir -p $(ODIR)/target/modules
	@mkdir -p $(ODIR)/target/fs
	@mkdir -p $(ODIR)/target/fs/grubfs
	@mkdir -p $(ODIR)/target/fs/hfs
	@mkdir -p $(ODIR)/target/fs/hfsplus
	@mkdir -p $(ODIR)/target/drivers
	@mkdir -p $(ODIR)/target/libc
	@mkdir -p $(ODIR)/host/include
	@mkdir -p $(ODIR)/host/kernel
	@mkdir -p $(ODIR)/forth
	@ln -s $(PWD)/include/$(ARCH) $(ODIR)/target/include/asm
	@#compile the host binary with target settings instead
	@#ln -s $(PWD)/include/$(HOSTARCH) $(ODIR)/host/include/asm
	@echo "ok."

# This is needed because viewvc messes with the permissions of executables:
prepare:
	@chmod 755 utils/dist/debian/rules
	@chmod 755 config/scripts/switch-arch
	@chmod 755 config/scripts/archname
	@chmod 755 config/scripts/reldir
	@chmod 755 config/scripts/crosscflags

xml: directories
	@printf "Creating target Makefile..."
	@xsltproc config/xml/xinclude.xsl build.xml > $(ODIR)/build-full.xml
	@xsltproc config/xml/makefile.xsl $(ODIR)/build-full.xml > $(ODIR)/Makefile
	@echo "ok."
	@printf "Creating config files..."
	@xsltproc config/xml/config-c.xsl config.xml > $(ODIR)/host/include/autoconf.h
	@xsltproc config/xml/config-c.xsl config.xml > $(ODIR)/target/include/autoconf.h
	@xsltproc config/xml/config-forth.xsl config.xml > $(ODIR)/forth/config.fs
	@echo "ok."

build: xml
	@printf "Building..."
	@( $(MAKE) -f $(ODIR)/Makefile "CROSSCFLAGS=$(CROSSCFLAGS)" > $(ODIR)/build.log 2>&1 && echo "ok." ) || \
		( echo "error:"; tail -15 $(ODIR)/build.log )

build-verbose:
	@echo "Building..."
	$(MAKE) -f $(ODIR)/Makefile "CROSSCFLAGS=$(CROSSCFLAGS)"

run: 
	@echo "Running..."
	@$(ODIR)/openbios-unix $(ODIR)/openbios-unix.dict


# The following two targets will only work on x86 so far.
# 
$(ODIR)/openbios.iso: $(ODIR)/openbios.multiboot $(ODIR)/openbios-x86.dict
	@mkisofs -input-charset UTF-8 -r -b boot/grub/stage2_eltorito -no-emul-boot \
	-boot-load-size 4 -boot-info-table -o $@ utils/iso $^

runiso: $(ODIR)/openbios.iso
	qemu -cdrom $^

## openbios-sparc 1.0~alpha2+20080106

=== Makefile ===
--- 
+++ 
@@ -42,6 +42,7 @@
 	@mkdir -p $(ODIR)/target/arch/ppc/briq # no autodetection of those..
 	@mkdir -p $(ODIR)/target/arch/ppc/pearpc
 	@mkdir -p $(ODIR)/target/arch/ppc/mol
+	@mkdir -p $(ODIR)/target/arch/ppc/qemu
 	@mkdir -p $(ODIR)/target/arch/x86
 	@mkdir -p $(ODIR)/target/arch/x86/xbox
 	@mkdir -p $(ODIR)/target/libgcc

## openbios-sparc 1.0

=== Makefile ===
HOSTARCH=$(shell config/scripts/archname)
ODIRS=$(wildcard obj-*)
TARGETS=$(subst obj-,,$(ODIRS))

all: requirements info build

requirements:
	@which xsltproc &>/dev/null || ( echo ; echo "Please install libxslt2"; \
			echo; exit 1 )

info:
	@echo "Building OpenBIOS on $(HOSTARCH) for $(TARGETS)"

clean:
	@printf "Cleaning up..."
	@rm -rf $(ODIRS) forth.dict.core
	@find . -type f -name "*~" -exec rm \{\} \;
	@echo " ok"

build:
	@printf "Building..."
	@for dir in $(ODIRS); do \
		$(MAKE) -C $$dir > $$dir/build.log 2>&1 && echo "ok." || \
		( echo "error:"; tail -15 $$$dir/build.log; exit 1 ) \
	done

build-verbose:
	@echo "Building..."
	@for dir in $(ODIRS); do \
		$(MAKE) -C $$dir || exit 1; \
	done

run:
	@echo "Running..."
	@$(ODIR)/openbios-unix $(ODIR)/openbios-unix.dict


# The following two targets will only work on x86 so far.
# 
$(ODIR)/openbios.iso: $(ODIR)/openbios.multiboot $(ODIR)/openbios-x86.dict
	@mkisofs -input-charset UTF-8 -r -b boot/grub/stage2_eltorito -no-emul-boot \
	-boot-load-size 4 -boot-info-table -o $@ utils/iso $^

runiso: $(ODIR)/openbios.iso
	qemu -cdrom $^

## openbios-sparc 1.0+svn1018

=== debian/changelog ===
openbios-sparc (1.0+svn1018-1) unstable; urgency=low

  * New upstream snapshot, compatible with qemu 0.14.x.
  * Add conflicts with qemu-system (<< 0.14.0).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 19 Feb 2011 11:53:29 +0100

openbios-sparc (1.0+svn821-2) experimental; urgency=low

  * Relax conflicts on qemu-system to (<< 0.13.0~). 

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 02 Aug 2010 21:30:19 +0200

openbios-sparc (1.0+svn821-1) experimental; urgency=low

  * New upstream snapshot, compatible with qemu 0.13.x.
  * Add conflicts with qemu-system (<< 0.13.0).
  * Bump Standards-Version to 3.9.1 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 30 Jul 2010 22:55:26 +0200

openbios-sparc (1.0+svn640-1) unstable; urgency=low

  * New upstream snapshot, compatible with qemu 0.12.x.
  * Add conflicts with qemu-system (<< 0.12.0).
  * Bump Standards-Version to 3.8.4 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 27 Feb 2010 23:23:56 +0100

openbios-sparc (1.0-1) unstable; urgency=low

  * New upstream version.
  * Conflicts with qemu (<< 0.10.0).
  * debian/copyright: add two missing copyright entries. 

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 07 Mar 2009 15:10:33 +0100

openbios-sparc (1.0~alpha2+20081109-1) experimental; urgency=low

  * New SVN snapshot targeted to experimental.
  * Conflicts with qemu (<< 0.9.1+svn20081012-1).
  * Bump Standards-Version to 3.8.0 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 09 Nov 2008 14:36:25 +0100

openbios-sparc (1.0~alpha2+20080106-2) unstable; urgency=low

  * Conflict with qemu (<< 0.9.1) (closes: #462334). 

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 24 Jan 2008 01:51:33 +0100

openbios-sparc (1.0~alpha2+20080106-1) unstable; urgency=low

  * New SVN snapshot.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 06 Jan 2008 18:40:44 +0100

openbios-sparc (1.0~alpha2+20070816-1) unstable; urgency=low

  * Initial Release (closes: #438178).

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 16 Aug 2007 00:28:39 +0200

=== debian/control ===
Source: openbios-sparc
Maintainer: Aurelien Jarno <aurel32@debian.org>
Section: misc
Priority: extra
Build-Depends: debhelper (>= 6.0.7), fcode-utils, xsltproc
Standards-Version: 3.9.1
Homepage: http://www.openbios.org/

Package: openbios-sparc
Architecture: all
Depends: ${misc:Depends}
Conflicts: qemu (<< 0.10.0), qemu-system ( << 0.14.0)
Suggests: qemu
Description: SPARC Open Firmware
 OpenBIOS is a free, portable implementation of IEEE 1275-1994 
 (Open Firmware).
 .
 This package contains the SPARC 32-bit and SPARC 64-bit versions
 of OpenBIOS.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -e '/^Version/!d' -e 's/^Version: //g' -e 's/-.*//g')
UPSTREAM_REVISION=$(shell echo $(UPSTREAM_VERSION) | sed -e 's/.*svn/-r/')
UPSTREAM_SVN=svn://openbios.org/openbios/trunk/openbios-devel
UPSTREAM_CHECKOUT=openbios-sparc-$(UPSTREAM_VERSION)

DEB_BUILD_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)

get-orig-source:
	svn export $(UPSTREAM_REVISION) $(UPSTREAM_SVN) $(UPSTREAM_CHECKOUT)
	rm -fr openbios-sparc-$(UPSTREAM_VERSION)/utils/iso
	tar -zcf ../openbios-sparc_$(UPSTREAM_VERSION).orig.tar.gz $(UPSTREAM_CHECKOUT)
	rm -rf $(UPSTREAM_CHECKOUT)

build: build-stamp
build-stamp:
	dh_testdir

ifeq (,$(findstring $(DEB_BUILD_ARCH_CPU),sparc sparc64))
	@echo "This package must be built on a SPARC machine"
	@false
endif

	config/scripts/switch-arch builtin-sparc32 builtin-sparc64
	cd obj-sparc32 && $(MAKE) all CC="gcc -m32" HOSTCC="gcc -m32" TARGET=""
	cd obj-sparc64 && $(MAKE) all CC="gcc -m64" HOSTCC="gcc -m64" TARGET=""

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -rf obj-*
	rm -f config.xml rules.xml
	rm -f *-stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	mkdir -p $(CURDIR)/debian/openbios-sparc/usr/share/openbios
	install -m644 obj-sparc32/openbios-builtin.elf $(CURDIR)/debian/openbios-sparc/usr/share/openbios/openbios-sparc32
	install -m644 obj-sparc64/openbios-builtin.elf $(CURDIR)/debian/openbios-sparc/usr/share/openbios/openbios-sparc64


# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installchangelogs Documentation/ChangeLog.arch
	dh_lintian
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install
# We have nothing to do by default.

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## openbios-sparc 1.0+svn1047

=== debian/changelog ===
openbios-sparc (1.0+svn1047-1) unstable; urgency=low

  * New upstream snapshot, compatible with qemu 1.0.x. 
  * Bump Standards-Version to 3.9.2:
    - Add build-indep and build-arch targets.
  * Update lintian overrides to the new format.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 08 Jan 2012 13:32:54 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: misc
 Priority: extra
 Build-Depends: debhelper (>= 6.0.7), fcode-utils, xsltproc
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://www.openbios.org/
 
 Package: openbios-sparc

## openbios-sparc 1.0+svn1060

=== debian/changelog ===
openbios-sparc (1.0+svn1060-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 29 Oct 2012 15:54:30 +0400

openbios-sparc (1.0+svn1060-1) unstable; urgency=low

  * New upstream snapshot, shipped with qemu 1.1.0.
  * Bump Standards-Version to 3.9.3 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 09 Jun 2012 14:15:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: openbios-sparc
 Maintainer: Aurelien Jarno <aurel32@debian.org>
+Uploaders: Michael Tokarev <mjt@tls.msk.ru>
 Section: misc
 Priority: extra
 Build-Depends: debhelper (>= 6.0.7), fcode-utils, xsltproc
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://www.openbios.org/
 
 Package: openbios-sparc

=== debian/rules ===
--- 
+++ 
@@ -18,8 +18,13 @@
 	tar -zcf ../openbios-sparc_$(UPSTREAM_VERSION).orig.tar.gz $(UPSTREAM_CHECKOUT)
 	rm -rf $(UPSTREAM_CHECKOUT)
 
-build: build-stamp
-build-stamp:
+build: build-arch build-indep
+
+build-arch:
+# We have nothing to do by default.
+
+build-indep: build-indep-stamp
+build-indep-stamp:
 	dh_testdir
 
 ifeq (,$(findstring $(DEB_BUILD_ARCH_CPU),sparc sparc64))
@@ -31,7 +36,7 @@
 	cd obj-sparc32 && $(MAKE) all CC="gcc -m32" HOSTCC="gcc -m32" TARGET=""
 	cd obj-sparc64 && $(MAKE) all CC="gcc -m64" HOSTCC="gcc -m64" TARGET=""
 
-	touch build-stamp
+	touch build-indep-stamp
 
 clean:
 	dh_testdir
@@ -41,7 +46,7 @@
 	rm -f *-stamp
 	dh_clean
 
-install: build
+install: build-indep
 	dh_testdir
 	dh_testroot
 	dh_clean -k
@@ -53,7 +58,7 @@
 
 
 # Build architecture-independent files here.
-binary-indep: build install
+binary-indep: build-indep install
 	dh_testdir
 	dh_testroot
 	dh_installdocs
@@ -69,8 +74,8 @@
 	dh_builddeb
 
 # Build architecture-dependent files here.
-binary-arch: build install
+binary-arch: build-indep install
 # We have nothing to do by default.
 
 binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install
+.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install

## openbios-sparc 1.1+svn1306

=== debian/changelog ===
openbios-sparc (1.1+svn1306-1) unstable; urgency=medium

  * New upstream version for QEMU 2.1.x releases. 
  * Drop patches/01-forthstrap-unaligned.diff (merged upstream).
  * Drop patches/02-forth-stack-underflow.diff (merged upstream).
  * Drop patches/03-sparc32-booting-device.diff (merged upstream).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 02 Aug 2014 14:17:24 +0200

openbios-sparc (1.1+svn1229-1) unstable; urgency=low

  * New upstream version for QEMU 1.7.x releases.
  * Mark openbios-sparc as Multi-Arch: foreign.
  * Bump Standards-Version to 3.9.5.0 (no changes).
  * Build-depends on gcc-multilib. Force HOSTARCH to sparc64 to be able to
    build this package in a linux32 environment.
  * Install QEMU,tcx.bin for sparc32 (closes: #731643).
  * Add patches/01-forthstrap-unaligned.diff to fix unaligned access in
    forthstrap during build.
  * Add patches/02-forth-stack-underflow.diff and
    patches/03-sparc32-booting-device.diff to fix sparc32 boot from disk.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 11 Dec 2013 07:25:49 +0100

openbios-sparc (1.1-1) unstable; urgency=low

  * New upstream version for QEMU 1.5.x releases.
  * Refresh debian/patches/01_kernel-headers.diff.
  * Switch maintainer to the Debian QEMU Team, add myself as uploader.
  * Add Vcs-* field.
  * Switch to debhelper compatibility level 7.
  * Use dh_prep instead of dh_clean -k.
  * Compress sources and binaries with xz.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 06 May 2013 21:41:01 +0200

=== debian/control ===
Source: openbios-sparc
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>
Section: misc
Priority: extra
Build-Depends: debhelper (>= 7), gcc-multilib, fcode-utils, xsltproc
Standards-Version: 3.9.5.0
Homepage: http://www.openbios.org/
Vcs-Browser: http://git.debian.org/?p=pkg-qemu/openbios-sparc.git
Vcs-Git: git://git.debian.org/git/pkg-qemu/openbios-sparc.git

Package: openbios-sparc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: qemu (<< 0.10.0), qemu-system ( << 0.14.0)
Suggests: qemu
Description: SPARC Open Firmware
 OpenBIOS is a free, portable implementation of IEEE 1275-1994 
 (Open Firmware).
 .
 This package contains the SPARC 32-bit and SPARC 64-bit versions
 of OpenBIOS.

=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,7 @@
 	@false
 endif
 
-	config/scripts/switch-arch builtin-sparc32 builtin-sparc64
+	HOSTARCH=sparc64 config/scripts/switch-arch builtin-sparc32 builtin-sparc64
 	cd obj-sparc32 && $(MAKE) all CC="gcc -m32" HOSTCC="gcc -m32" TARGET=""
 	cd obj-sparc64 && $(MAKE) all CC="gcc -m64" HOSTCC="gcc -m64" TARGET=""
 
@@ -49,11 +49,12 @@
 install: build-indep
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
 
 	mkdir -p $(CURDIR)/debian/openbios-sparc/usr/share/openbios
 	install -m644 obj-sparc32/openbios-builtin.elf $(CURDIR)/debian/openbios-sparc/usr/share/openbios/openbios-sparc32
+	install -m644 obj-sparc32/QEMU,tcx.bin $(CURDIR)/debian/openbios-sparc/usr/share/openbios/QEMU,tcx.bin
 	install -m644 obj-sparc64/openbios-builtin.elf $(CURDIR)/debian/openbios-sparc/usr/share/openbios/openbios-sparc64
 
 
@@ -71,10 +72,10 @@
 	dh_installdeb
 	dh_gencontrol
 	dh_md5sums
-	dh_builddeb
+	dh_builddeb -- -Zxz
 
 # Build architecture-dependent files here.
-binary-arch: build-indep install
+binary-arch: build-arch install
 # We have nothing to do by default.
 
 binary: binary-indep binary-arch
